//*****************************************
//@@ohbPUePWSV ZvvO@uQ
//@@ PIC16F1847 AKE MUTU Clock Program
//
// File Name:Pic_iic.c
//
//  Use MSSSP
//
//  RB4(SCL): IIC-SCL
//  RB1(SDA): IIC-SDA
//
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2014/02/25  New(TAB4)  Taishi
//  2014/04/30  Modify for 16F1827  Taishi
//  2015/05/09  modify for 16F1847
//*****************************************
#include	<htc.h>

#include	"16F1847_ake6_clock2.h"
#include	"Pic_iic.h"

#define MAX_TRIES 50

unsigned char	gIic_status;

// 16F1827 ̃rbg`
// SSPxCON1
#define	WCOL	0b10000000
#define	SSPOV	0b01000000
#define	SSPEN	0b00100000
#define	CKP		0b00010000
#define	SSPM3   0b00001000
#define	SSPM2   0b00000100
#define	SSPM1   0b00000010
#define	SSPM0   0b00000001

// SSPxCON2
#define	GCEN	0b10000000
#define	ACKSTAT 0b01000000
#define	ACKDT	0b00100000
#define	ACKEN   0b00010000
#define	RCEN    0b00001000
#define	PEN     0b00000100
#define	RSEN    0b00000010
#define	SEN     0b00000001

// SSPxCON3
#define	ACKTIM  0b10000000
#define	PCIE    0b01000000
#define	SCIE 	0b00100000
#define	BOEN    0b00010000
#define	SDAHT   0b00001000
#define	ABCDE   0b00000100
#define	AHEN    0b00000010
#define	DHEN    0b00000001

// SSPxMSK 
#define	MSK7	0b10000000
#define	MSK6    0b01000000
#define	MSK5 	0b00100000
#define	MSK4    0b00010000
#define	MSK3    0b00001000
#define	MSK2    0b00000100
#define	MSK1    0b00000010
#define	MSK0    0b00000001

#ifdef		TWI_DEBUG_ENABLE
// fobOpǂݏf[^
static unsigned char	gTwi_TWDR_Write[16];	// for Debug
static unsigned char	gTwi_TWDR_Write_pos;	// for Debug
static unsigned char	gTwi_TWDR_Read[16];		// for Debug
static unsigned char	gTwi_TWDR_Read_pos;		// for Debug
static unsigned char	gTwi_TWDR_WStat[16];	// for Debug
static unsigned char	gTwi_TWDR_WStat_pos;	// for Debug

// ************************************
// TWI fobOp݃f[^̎o
//   @cp:PU̃f[^鏊
//        ߂̕@Âق֋߂ɓ
//        cp+0 ߂ŁAcp+15 ԌÂ
//  ߂l Ȃ
// ************************************
void	twi_debug_Load_WriteData(unsigned char *cp)
{
	unsigned char	uc;
	unsigned char	i;

	uc = gTwi_TWDR_Write_pos;
	for(i=0;i<16;i++){
		uc--;
		gTwi_TWDR_Write_pos &= 0x0f;
		*(cp + i) = gTwi_TWDR_Write[uc];
	}
}
// ************************************
// TWI fobOpǂݏof[^̎o
//   @cp:PU̃f[^鏊
//        ߂̕@Âق֋߂ɓ
//        cp+0 ߂ŁAcp+15 ԌÂ
//  ߂l Ȃ
// ************************************
void	twi_debug_Load_ReadData(unsigned char *cp)
{
	unsigned char	uc;
	unsigned char	i;

	uc = gTwi_TWDR_Read_pos;
	for(i=0;i<16;i++){
		uc--;
		gTwi_TWDR_Read_pos &= 0x0f;
		*(cp + i) = gTwi_TWDR_Read[uc];
	}
}
// ************************************
// TWI fobOpݎԃf[^̎o
//   @cp:PU̃f[^鏊
//        ߂̕@Âق֋߂ɓ
//        cp+0 ߂ŁAcp+15 ԌÂ
//  ߂l Ȃ
// ************************************
void	twi_debug_Load_WStatData(unsigned char *cp)
{
	unsigned char	uc;
	unsigned char	i;

	uc = gTwi_TWDR_WStat_pos;
	for(i=0;i<16;i++){
		uc--;
		gTwi_TWDR_WStat_pos &= 0x0f;
		*(cp + i) = gTwi_TWDR_WStat[uc];
	}
}
// ************************************
// TWI fobOpf[^̏ݒ
//   @Ȃ
//  ߂l Ȃ
// ************************************
static
void	twi_debug_data_init(void)
{
	unsigned char	i;

	for(i=0;i<16;i++){
		gTwi_TWDR_Write[i] = 0xff;
		gTwi_TWDR_Read[i] = 0xff;
		gTwi_TWDR_WStat[i] = 0xff;
	}

	gTwi_TWDR_Write_pos = 0;
	gTwi_TWDR_Read_pos = 0;
	gTwi_TWDR_WStat_pos = 0;

}

// ************************************
// TWI fobOp݃f[^̕ۑ
//   @Ȃ
//  ߂l Ȃ
// ************************************
static
void	twi_debug_Save_WriteData(unsigned char d)
{
	gTwi_TWDR_Write[gTwi_TWDR_Write_pos] = d;

	gTwi_TWDR_Write_pos++;
	gTwi_TWDR_Write_pos &= 0x0f;
}

// ************************************
// TWI fobOpǂݏof[^̕ۑ
//   @Ȃ
//  ߂l Ȃ
// ************************************
static
void	twi_debug_Save_ReadData(unsigned char d)
{
	gTwi_TWDR_Read[gTwi_TWDR_Read_pos] = d;

	gTwi_TWDR_Read_pos++;
	gTwi_TWDR_Read_pos &= 0x0f;
}
// ************************************
// TWI fobOpݎԃf[^̕ۑ
//   @Ȃ
//  ߂l Ȃ
// ************************************
static
void	twi_debug_Save_WStatData(unsigned char d)
{
	gTwi_TWDR_WStat[gTwi_TWDR_WStat_pos] = d;

	gTwi_TWDR_WStat_pos++;
	gTwi_TWDR_WStat_pos &= 0x0f;
}
#endif		//TWI_DEBUG_ENABLE

// ************************************
// IIC ݒigpJnj
//   @Ȃ
//  ߂l Ȃ
// ************************************
void	iic_init(void)
{

//	TRISC0 = 1;							//input
//	TRISC1 = 1;							//input
	TRISB1 = 1;							//input
	TRISB4 = 1;							//input

	SSP1CON1 = 0b00101000;				// I2C Enable, Master mode
	SSP1CON2 = 0b00000000;
//	SSPADD  = 79;						// 100kHz at 32MHz Fosc
//	SSPADD  = 39;						// 100kHz at 16MHz Fosc
	SSPADD  = 19;						// 100kHz at 8MHz Fosc
//	SSPADD  =  9;						// 100kHz at 4MHz Fosc
	SSP1STAT = 0b11000000;
	SSP1STAT = 0b10000000;

}
// ************************************
// IIC M҂iAChԂɂȂ܂ő҂j
//   @Ȃ
//  ߂l Ȃ
// ************************************
void	iic_wait_idle(void)
{
	while((SSP1CON2 & 0x1f) || (SSP1STAT & 0x04)){
		;
	}
}
// ************************************
// IIC gpI
//   @Ȃ
//  ߂l Ȃ
// ************************************
void	iic_close(void)
{
//	SSPEN = 0;				// iic ~
	SSP1CON1 &= ~SSPEN;
}

// ************************************
// IIC Jn
//     Ȃ
//  ߂lFȂ
//
// ************************************
void	iic_start(void)
{
	iic_wait_idle();
//	SEN = 1;
	SSP1CON2 |= SEN;
}
// ************************************
// IIC ĊJ
//     Ȃ
//  ߂lFȂ
//
// ************************************
void	iic_restart(void)
{
	iic_wait_idle();
//	RSEN = 1;
	SSP1CON2 |= RSEN;
}
// ************************************
// IIC ~
//     Ȃ
//  ߂l Ȃ
//
// ************************************
void iic_stop(void)
{
	iic_wait_idle();
//	PEN = 1;
	SSP1CON2 |= PEN;
}
// ************************************
// IIC 
//     data: ݃f[^
//  ߂lFȂ
//
// ************************************
void	iic_write(unsigned char data)
{
	iic_wait_idle();
	SSPBUF = data;
}
// ************************************
// IIC AhXM
//     dev_id: foCXhciʂSrbgj
//       dev_addr: foCXAhXiʂSrbg̓̏RrbgAcP`cRj
//        rw_type: IIC_WRITE=0 or IIC_READ=1
//  ߂lF0= JnԂɂȂB 1=JnԂɂȂȂ
//
//  ʂ҂Ĕ
// ************************************
void	iic_address(unsigned int dev_id, unsigned int dev_addr, unsigned char rw_type)
{
	unsigned char	adres;

	adres = ( (dev_id & 0xF0) | (dev_addr & 0x0E) | rw_type);			// ǂ  Ɂ@foCXhcƃfoCXAhXt f[^WX^ɃZbg
	iic_wait_idle();
	SSPBUF = adres;
}
// ************************************
// IIC PoCgǂݏo
//     
//	ack_type: 1:LA 0:
//  ߂lFǂݏof[^
//
// ************************************
unsigned char	iic_read(char ack_type)
{
	unsigned char	read_data;

	iic_wait_idle();
//	RCEN = 1;					// MCl[u
	SSP1CON2 |= RCEN;
	iic_wait_idle();
	read_data = SSPBUF;
	iic_wait_idle();
	if(ack_type == 1){
//		ACKDT = 0;				// `bjL
		SSP1CON2 &= ~ACKDT;
	}else{
//		ACKDT = 1;				// `bj
		SSP1CON2 |= ACKDT;
	}
//	ACKEN = 1;
	SSP1CON2 |= ACKEN;

	return(read_data);
}
