//*****************************************
//@@ohbPUePWSV ZvvO@uQ
//@@ PIC16F1847 AKE MUTU Clock Program
//
// File Name:Rtc_PCF8563.c
//
//  RB4(SCL): IIC-SCL
//  RB1(SDA): IIC-SDA
//
//
//   MPLAB IDE v8.84  HiTEC C
//
//  2014/02/25  New(TAB4) for 16F1824  Taishi
//  2014/04/30  Modify for 16F1827  Taishi
//  2015/05/09  modify for 16F1847
//*****************************************
#include	<htc.h>

#include	"16F1847_ake6_clock2.h"
#include	"Pic_iic.h"
#include	"LCD.h"

#include	"Rtc_PCF8563.h"

unsigned char	gRTC_sec;				// qsb b̃f[^ (BCD 0--59)
unsigned char	gRTC_min;				// qsb ̃f[^ (BCD 0--59)
unsigned char	gRTC_hou;				// qsb ̃f[^ (BCD 0--23j
unsigned char	gRTC_wday;				// qsb j̃f[^ (BCD 1--7)
unsigned char	gRTC_day;				// qsb ̃f[^ (BCD 1--31)
unsigned char	gRTC_mon;				// qsb ̃f[^ (BCD 1--12j
unsigned char	gRTC_year;				// qsb Ñf[^ (BCD 0--99)
unsigned char	gRTC_control;			// qsb Rg[̃f[^
unsigned char	gRTC_status;			// qsb XeC^X̃f[^
unsigned char	gRTC_register_d;		// qsbWX^[0x0d] ̑ւ
unsigned char	gRTC_register_e;		// qsbWX^[0x0e] ̑ւ
unsigned char	gRTC_register_f;		// qsbWX^[0x0f] ̑ւ
unsigned char	rtc_05s_count;			// qsbĂ鎞̂ODTboߗp

unsigned char	adj_pass = 0;			// }CiXf[^Ł@xĂ܂}CiX鎖h
signed char		bityousei[24];			// OOQR܂ł̔li|X`{Xje̖ɒl߂KvL
signed char		bityousei_sum;			// l̃T

const signed char		bityousei_org[24] = {		// ddoqnlĂ̂OOQR܂ł̔li|X`{Xje̖ɒl߂KvL
//  0   1   2   3   4   5   6   7   8   9  10  12
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,

// 13  14  15  16  17  18  19  20  21  22  23  24
   -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1,
	};

#define	EEP_ADR_BITYOU					0		// lĂ
#define	EEP_ADR_BITYOU_SUM				24		// lTĂ

#ifdef		HARD_TEST							// n[h̃`FbN̎
unsigned char	gRTC_register[16];
#endif

// *****************************
// EEPROM Read/Write
//  : adr=ddoqnl̃AhX(0--255)
//        dat=ddoqnlɏf[^̃|C^A͓ǂݏof[^|C^
//        wr = 1:Write, 0:Read
//  ̊֐ĂԎɂ͊݋֎~̕KvL
// *****************************
void	eep_read_write(unsigned char adr, unsigned char *dt, unsigned char wr)
{
	if(wr == 1){					// at Write
		EEPROM_WRITE(adr, *dt);
	}else{							// at Read
		while(WR)continue;
		*dt = EEPROM_READ(adr);
	}
}

//***************************
// l̃T߂
//***************************
signed char	get_bityou_sum(void)
{
	unsigned char	uc;
	signed char		s;

	for(s = 0,uc = 0; uc < 24; uc++){
		s += bityousei[uc];
	}

	return(s);
}
//***************************
// llɂ
//***************************
void 	set_bityou_org(void)
{
	unsigned char	uc;

	for(uc = 0; uc < 24; uc++){
		bityousei[uc] = bityousei_org[uc];		// OOQR܂ł̔l
	}
}
//***************************
// l
//   ɔlƃT
//***************************
void	wtite_bityousei(void)
{
	unsigned char	uc;

	for(uc = 0; uc < 24; uc++){
		eep_read_write(EEP_ADR_BITYOU + uc, (unsigned char *)(&bityousei[uc]), 1);		// OOQR܂ł̔l
	}
	eep_read_write(EEP_ADR_BITYOU_SUM, (unsigned char *)(&bityousei_sum), 1);		// OOQR܂ł̔T
}
//***************************
// lǂݏo
//   Ă鎞͏lɂ
//***************************
void	read_bityousei(void)
{
	unsigned char	uc;
	unsigned char	s;					// lT

	for(uc = 0; uc < 24; uc++){
		eep_read_write(EEP_ADR_BITYOU + uc, (unsigned char *)(&bityousei[uc]), 0);		// OOQR܂ł̔lǏo
		wait_10ms(5);
	}

	bityousei_sum = get_bityou_sum();				// l̃T߂
	eep_read_write(EEP_ADR_BITYOU_SUM, (unsigned char *)(&bityousei_sum), 0);		// OOQR܂ł̔T
	s = get_bityou_sum();							// l̃TvZŋ߂
	if (s != bityousei_sum){						// Ⴄ
		for(uc = 0; uc < 24; uc++){
			bityousei[uc] = bityousei_org[uc];		// OOQR܂ł̔l
		}
		bityousei_sum = get_bityou_sum();			// l̃TvZŋ߂
		wtite_bityousei();							// l
		gSet_bityo = 1;								// lC
	}
}

//***************************
// RTC Rg[f[^ǂݏo
//  ǂݏof[^ gRTC_controlgRTC_status ɓ
//
//	PCF8563_ID		0xA0	// I2C PCF8563 Device Identifier
//	PCF8563_ADDR	0x02	// I2C PCF8563 Device Address
//  IIC_READ		1
//  IIC_WRITE		0
//
//***************************
void	rtc_control_read_PCF8563(void)
{
	unsigned char	data;

	iic_start();										// IIC Jn
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_WRITE);		// foCXhcƃfoCXAhXƂvqhsd
	iic_write(RTC_CONTROL_status1_ADDR_PCF8563);		// IIC Ǐo AhX

	iic_restart();
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_READ);		// foCXhcƃfoCXAhXƂqd`c

	data = iic_read(IIC_ACK);							// IIC ǂݏo
	gRTC_control = data;								// qsb Rg[|XeC^XP̃f[^

	data = iic_read(IIC_NACK);							// IIC ǂݏo Ō NACK=0
	gRTC_status = data;									// qsb Rg[|XeC^XQ̃f[^

	iic_stop();

}
//***************************
// RTC Rg[f[^
//  ݃f[^ gRTC_controlgRTC_status ɓĂ镨Ƃ
//***************************
void 	rtc_control_write_PCF8563(void)
{
	iic_start();										// IIC Jn
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_WRITE);		// foCXhcƃfoCXAhXƂvqhsd
	iic_write(RTC_CONTROL_status1_ADDR_PCF8563);		// IIC  AhX
	iic_write(gRTC_control);							// Rg[f[^
	iic_write(gRTC_status);								// XeC^Xf[^

	iic_stop();

}
//***************************
// RTC NbNo̓Rg[ǂݏo
//  ǂݏof[^ gRTC_register_d ɓ
//
//	PCF8563_ID		0xA0	// I2C PCF8563 Device Identifier
//	PCF8563_ADDR	0x02	// I2C PCF8563 Device Address
//  IIC_READ		1
//  IIC_WRITE		0
//
//***************************
void	rtc_CLKOUT_read_PCF8563(void)
{
	unsigned char	data;

	iic_start();										// IIC Jn
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_WRITE);		// foCXhcƃfoCXAhXƂvqhsd
	iic_write(RTC_CLKOUT_control_ADDR_PCF8563);			// IIC Ǐo AhX

	iic_restart();
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_READ);		// foCXhcƃfoCXAhXƂqd`c

	data = iic_read(IIC_NACK);							// IIC ǂݏo Ō NACK=0
	gRTC_register_d = data;								// qsb NbNo̓Rg[

	iic_stop();
}
//***************************
// RTC NbNo̓Rg[f[^
//  ݃f[^ gRTC_register_d ɓĂ镨Ƃ
//***************************
void	rtc_CLKOUT_write_PCF8563(void)
{
	iic_start();										// IIC Jn
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_WRITE);		// foCXhcƃfoCXAhXƂvqhsd
	iic_write(RTC_CLKOUT_control_ADDR_PCF8563);			// IIC  AhX
	iic_write(gRTC_register_d);							// Rg[f[^

	iic_stop();

}
//***************************
// RTC ^C}[Rg[ǂݏo
//  ǂݏof[^ gRTC_register_e  gRTC_register_f ɓ
//
//	PCF8563_ID		0xA0	// I2C PCF8563 Device Identifier
//	PCF8563_ADDR	0x02	// I2C PCF8563 Device Address
//  IIC_READ		1
//  IIC_WRITE		0
//
//***************************
void	rtc_TIMER_read_PCF8563(void)
{
	unsigned char	data;

	iic_start();										// IIC Jn
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_WRITE);		// foCXhcƃfoCXAhXƂvqhsd
	iic_write(RTC_Timer_control_ADDR_PCF8563);			// IIC Ǐo AhX

	iic_restart();
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_READ);		// foCXhcƃfoCXAhXƂqd`c

	data = iic_read(IIC_ACK);							// IIC ǂݏo
	gRTC_register_e = data;								// qsb ^C}[o̓Rg[

	data = iic_read(IIC_NACK);							// IIC ǂݏo Ō NACK=0
	gRTC_register_f = data;								// qsb ^C}[f[^

	iic_stop();
}
//***************************
// RTC ^C}[Rg[f[^
//  ݃f[^ gRTC_register_e  gRTC_register_f ɓĂ镨Ƃ
//***************************
void	rtc_TIMER_write_PCF8563(void)
{
	iic_start();										// IIC Jn
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_WRITE);		// foCXhcƃfoCXAhXƂvqhsd
	iic_write(RTC_Timer_control_ADDR_PCF8563);			// IIC  AhX
	iic_write(gRTC_register_e);							// Rg[f[^
	iic_write(gRTC_register_f);							// ^C}[f[^

	iic_stop();

}
//***************************
// RTC Initial
//  qsb̏ݒ
//  O݁ioaOjg
//
//@߂l
//  @obNAbvdrŎ~܂Ȃ́@O
//  @dLAx~܂́@P
//***************************
unsigned char	rtc_init_PCF8563(void)
{
	unsigned char	r = 0;

	read_bityousei();							// lǂݏo

	iic_init();

	rtc_read_PCF8563();							// RTC ǂݏo
	if((gRTC_sec & 0x80)!=0){					// bWX^̂cVg̎̓IV[^ĂȂ̂
		gRTC_sec = 0x32;						// qsb b̃f[^ (BCD 0--59)
		gRTC_min = 0x59;						// qsb ̃f[^ (BCD 0--59)
		gRTC_hou = 0x23;						// qsb ̃f[^ (BCD 0--23j
		gRTC_wday = 0x07;						// qsb j̃f[^ (BCD 1--7)
		gRTC_day = 0x31;						// qsb ̃f[^ (BCD 1--31)
		gRTC_mon = 0x12;						// qsb ̃f[^ (BCD 1--12j
		gRTC_year = 0x13;						// qsb Ñf[^ (BCD 0--99)
		rtc_write_PCF8563();					// cVkɂĉ߂ď
		r = 1;
	}

	// Po͐ݒ
	//  RB0: Pulse In from RTC 
	TRISB0 = 1;									//RB0 input

	rtc_TIMER_read_PCF8563();					// RTC ^C}[Rg[ǂݏo
	gRTC_register_e = (RTC_Timer_control_TE_PCF8563 | RTC_Timer_control_TD0_PCF8563 | RTC_Timer_control_TD1_PCF8563);		// Timer enableA1/60Hz(1min) source clock
	gRTC_register_f = 1;						// Timer register = 1 (1 min)
	rtc_TIMER_write_PCF8563();					// RTC ^C}[Rg[f[^

	rtc_control_read_PCF8563();					// RTC Rg[f[^ǂݏo
	gRTC_control &= ~(RTC_CONTROL_status1_TESTC_PCF8563);
	gRTC_status   = (RTC_CONTROL_status2_TI_TP_PCF8563 | RTC_CONTROL_status2_TIE_PCF8563);
	rtc_control_write_PCF8563();				// RTC Rg[f[^

	OPTION_REG &= 0b10111111;					// GbWŊO(INTEDG:0)
	INTF = 0;									// O݃tONA
	INTE = 1;									// O݉

	return(r);
}

//***************************
// RTC ǂݏo
//  ǂݏof[^͈ȉ̕ϐɓ
//	unsigned char	gRTC_sec;		// qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;		// qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;		// qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_day;		// qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_date;		// qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;		// qsb ̃f[^ (BCD 1--12j
//	unsigned char	gRTC_year;		// qsb Ñf[^ (BCD 0--99)
//***************************
void	rtc_read_PCF8563(void)
{
	unsigned char	data;

	iic_start();										// IIC Jn
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_WRITE);		// foCXhcƃfoCXAhXƂvqhsd
	iic_write(RTC_VL_Second_ADDR_PCF8563);				// IIC Ǐo AhX

	iic_restart();
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_READ);		// foCXhcƃfoCXAhXƂqd`c

	data = iic_read(IIC_ACK);							// IIC ǂݏo
	gRTC_sec = data;									// b

	data = iic_read(IIC_ACK);							// IIC ǂݏo
	gRTC_min = (data & 0x7f);							// 

	data = iic_read(IIC_ACK);							// IIC ǂݏo
	gRTC_hou = (data & 0x3f);							// 

	data = iic_read(IIC_ACK);							// IIC ǂݏo
	gRTC_day = (data & 0x3f);							// 

	data = iic_read(IIC_ACK);							// IIC ǂݏo
	gRTC_wday = (data & 0x07)+1;						// j

	data = iic_read(IIC_ACK);							// IIC ǂݏo
	gRTC_mon = (data & 0x9f);							// 

	data = iic_read(IIC_NACK);							// IIC ǂݏo Ō NACK=0
	gRTC_year = data;									// N

	iic_stop();

}

//***************************
// RTC 
//  ݃f[^͈ȉ̕ϐɓĂ镨Ƃ
//	unsigned char	gRTC_sec;		// qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;		// qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;		// qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_wday;		// qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_day;		// qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;		// qsb ̃f[^ (BCD 1--12j
//	unsigned char	gRTC_year;		// qsb Ñf[^ (BCD 0--99)
//***************************
void	rtc_write_PCF8563(void)
{
	unsigned char	r;

	gRTC_sec &= 0x7F;

	iic_start();										// IIC Jn
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_WRITE);		// foCXhcƃfoCXAhXƂvqhsd
	iic_write(RTC_VL_Second_ADDR_PCF8563);				// IIC  AhX
	iic_write(gRTC_sec);								// b̃f[^ (BCD 0--59)
	iic_write(gRTC_min);								// ̃f[^ (BCD 0--59)
	iic_write(gRTC_hou);								// ̃f[^ (BCD 0--23j
	iic_write(gRTC_day);								// ̃f[^ (BCD 1--31)
	iic_write(gRTC_wday-1);								// j̃f[^ (BCD 1--7)
	iic_write(gRTC_mon);								// ̃f[^ (BCD 1--12j
	iic_write(gRTC_year);								// Ñf[^ (BCD 0--99)

	iic_stop();

}
//***************************
// RTC 
//  vf[^͈ȉ̕ϐɓĂ镨Ƃ(-9 <--> +9)
//	unsigned char	gRTC_sec;		// qsb b̃f[^ (BCD 0--59)
//	unsigned char	gRTC_min;		// qsb ̃f[^ (BCD 0--59)
//	unsigned char	gRTC_hou;		// qsb ̃f[^ (BCD 0--23j
//	unsigned char	gRTC_wday;		// qsb j̃f[^ (BCD 1--7)
//	unsigned char	gRTC_day;		// qsb ̃f[^ (BCD 1--31)
//	unsigned char	gRTC_mon;		// qsb ̃f[^ (BCD 1--12j
//	PԂɂPĂ΂
//  OQ̎ɔ
// ߂l@OFȂA@OȊOFi}CiXf[^͌ݎ߂AvXf[^͌ݎi߂j
//***************************
signed char	rtc_adjust_PCF8563(void)
{
	signed char		r=0;
	unsigned char	ji;
	signed char		byo;

	if(adj_pass != 0){													// ēxł̏h
		adj_pass = 0;
	}else{
		if(gRTC_min == 0x02){										// OQ̎
			gRTC_sec &= 0x7F;
			ji  = ((gRTC_hou >> 4)&0x0f)*10;						// ̂Qiւ̕ϊ
			ji += (gRTC_hou & 0x0f);
			r = bityousei[ji];										// OOQR܂ł̔li|X`{Xj
			if(r != 0){												// 鎞
				disp_one_char_lcd_G_10x16(0, 2, '/');
				byo = (signed char)((gRTC_sec >> 4)&0x0f)*10;		// b̂Qiւ̕ϊ
				byo += (signed char)(gRTC_sec & 0x0f);
				byo += r;											// 
				if(byo < 0){										// }CiXf[^̎
					byo = (60 + byo);
					gRTC_min = 0x01;								// ߂
					adj_pass = 1;
				}else if (60 <= byo){
					byo = (byo - 60);
					gRTC_min = 0x03;								// i߂
				}
				gRTC_sec = (unsigned char)((byo/10)*16 + byo%10);	// abcɕϊ
				iic_start();										// IIC Jn
				iic_address(PCF8563_ID,PCF8563_ADDR,IIC_WRITE);		// foCXhcƃfoCXAhXƂvqhsd
				iic_write(RTC_VL_Second_ADDR_PCF8563);				// IIC  AhX
				iic_write(gRTC_sec);								// b̃f[^ (BCD 0--59)
				iic_write(gRTC_min);								// b̃f[^ (BCD 0--59)
				iic_stop();

				disp_one_char_lcd_G_10x16(0, 2, ' ');
			}
		}
	}
	return(r);
}

 #ifdef		HARD_TEST							// n[h̃`FbN̎
//***************************
// RTC WX^ǂݏo
//  ǂݏof[^gRTC_register[16]̕ϐɏԂɓ
//***************************
void rtc_reg_read_PCF8563(void)
{
	iic_start();										// IIC Jn
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_WRITE);		// foCXhcƃfoCXAhXƂvqhsd
	iic_write(0x00);									// IIC Ǐo AhX

	iic_restart();
	iic_address(PCF8563_ID,PCF8563_ADDR,IIC_READ);		// foCXhcƃfoCXAhXƂqd`c

	gRTC_register[0x00] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x01] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x02] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x03] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x04] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x05] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x06] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x07] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x08] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x09] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x0a] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x0b] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x0c] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x0d] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x0e] = iic_read(IIC_ACK);				// IIC ǂݏo
	gRTC_register[0x0f] = iic_read(IIC_NACK);				// IIC ǂݏo

	iic_stop();
}
 #endif		//HARD_TEST											// n[h̃`FbN̎

