//*******************************************************
//@@ohbPUePWSV ZvvO@uQ
//@@ PIC16F1847 AKE MUTU Clock Program
//  file name: ake6.c
//
//   MPLAB IDE v8.84  HiTEC C
//   [C:\Program Files\HI-TECH Software\PICC\9.83\include\as16f1847.h] include 
//
//  2015/05/09  New  Programed by Taishi
//*******************************************************

#include	<htc.h>

#include	"16F1847_ake6_clock2.h"
#include	"Rtc_PCF8563.h"
#include	"ake6.h"
#include	"step_motor.h"

static
const	unsigned char	sTime_ake6_kure6[25][6] ={		//@@@@@@@@@@閾@@@
	{0x01,0x01,0x06,0x11,  0x17,0x07},					//[ 0] @P@P@UPPAPV@V
	{0x01,0x06,0x06,0x16,  0x17,0x18},					//[ 1] @P@U@UPUAPVPW
	{0x01,0x21,0x06,0x14,  0x17,0x31},					//[ 2] @PQP@UPSAPVRP
	{0x02,0x05,0x06,0x05,  0x17,0x45},					//[ 3] @Q@T@U@TAPVST
	{0x02,0x20,0x05,0x50,  0x18,0x00},					//[ 4] @QQO@TTOAPW@O
	{0x03,0x07,0x05,0x32,  0x18,0x13},					//[ 5] @R@V@TRQAPWPR
	{0x03,0x22,0x05,0x11,  0x18,0x26},					//[ 6] @RQQ@TPPAPWQU
	{0x04,0x06,0x04,0x49,  0x18,0x39},					//[ 7] @S@U@SSXAPWRX
	{0x04,0x21,0x04,0x28,  0x18,0x52},					//[ 8] @SQP@SQWAPWTQ
	{0x05,0x06,0x04,0x10,  0x19,0x06},					//[ 9] @T@U@SPOAPX@U
	{0x05,0x21,0x03,0x56,  0x19,0x20},					//[10] @TQP@RTUAPXQO
	{0x06,0x05,0x03,0x48,  0x19,0x31},					//[11] @U@T@RSWAPXRP
	{0x06,0x20,0x03,0x47,  0x19,0x38},					//[12] @UQO@RSVAPXRW
	{0x07,0x05,0x03,0x52,  0x19,0x38},					//[13] @V@T@RTQAPXRW
	{0x07,0x25,0x04,0x07,  0x19,0x28},					//[14] @VQT@S@VAPXQW
	{0x08,0x09,0x04,0x20,  0x19,0x13},					//[15] @W@X@SQOAPXPR
	{0x08,0x24,0x04,0x33,  0x18,0x54},					//[16] @WQS@SRRAPWTS
	{0x09,0x08,0x04,0x45,  0x18,0x32},					//[17] @X@W@SSTAPWRQ
	{0x09,0x23,0x04,0x57,  0x18,0x10},					//[18] @XQR@STVAPWPO
	{0x10,0x08,0x05,0x00,  0x17,0x48},					//[19] PO@W@T@OAPVSW
	{0x10,0x23,0x05,0x21,  0x17,0x29},					//[20] POQR@TQPAPVQX
	{0x11,0x07,0x05,0x34,  0x17,0x15},					//[21] PP@V@TRSAPVPT
	{0x11,0x22,0x05,0x48,  0x17,0x05},					//[22] PPQQ@TSWAPV@T
	{0x12,0x06,0x06,0x01,  0x17,0x03},					//[23] PQ@V@U@PAPV@R
	{0x12,0x22,0x06,0x11,  0x17,0x07},					//[24] PQQQ@UPPAPV@V
};

//***************************************
// abc@lɕϊ
//@
//@@Fiabcj
//@@Fiabcj
//***************************************
unsigned short	bcd_to_bin(unsigned short bcdh, unsigned short bcdm)
{
	unsigned short	r=0;
	unsigned short	h;
	unsigned short	m;

	h  = ((bcdh >> 4)&0x0f)*10 + (bcdh & 0x0f);			// 

	m  = ((bcdm >> 4)&0x0f)*10 + (bcdm & 0x0f);			// 

	r = (h * 60) + m;

	return(r);
}

//***************************************
// Á@̌̕vZ
//@
//@@FO=AP
//@@FJniabcj
//@@FJniabcj
//@@FIiabcj
//@@FIiabcj
//@̎͊JnI菬
//@̎͊JnI傫
//***************************************
unsigned short	keisan_hiru_yoru(unsigned char mode, unsigned short sh, unsigned short sm, unsigned short eh, unsigned short em)
{
	unsigned short	r=1;
	unsigned short	st;
	unsigned short	ed;

	st = bcd_to_bin(sh,sm);				// Jn@abclɕϊ
	ed = bcd_to_bin(eh,em);				// I@abclɕϊ
	if(mode != 0){						// 
		ed += (24 * 60);
	}
	r = ed - st;						// 
	return(r);
}

//***************************************
// ZÁ@Z@̌oߕ
//@
//@@FO=ZAPZ
//@@Fiabcj
//@@Fiabcj
//@@Fݎiabcj
//@@Fݕiabcj
//@̎͊茻ݎ@傫
//@̎͊茻ݎ@傫i͂QS߂j
//***************************************
unsigned short	keisan_keika(unsigned char mode, unsigned short rh, unsigned short rm, unsigned short nh, unsigned short nm)
{
	unsigned short	r=1;
	unsigned short	rf;
	unsigned short	nw;

	rf = bcd_to_bin(rh,rm);				// @abclɕϊ
	nw = bcd_to_bin(nh,nm);				// ݁@abclɕϊ
	if(nw < rf){						// QS߂
		nw += (60 * 24);
	}
	r = nw - rf;						// 
	return(r);

}

//***************************************
//  ݎ@uZAZv̈ʒu߂
//@@ݎ͈ȉɗL
//		gRTC_min; ̃f[^ (BCD 0--59)
//		gRTC_hou; ̃f[^ (BCD 0--23j
//		gRTC_day; ̃f[^ (BCD 1--31)
//		gRTC_mon; ̃f[^ (BCD 1--12j
//@@iPAQSԕj͂VQO|CgipXj
//@@̂Öʒu͖ZƂAZ̈ʒu #Step_of_Round ̔@Ƃ
//@@̕Á̕@ꂼUƂ
//***************************************
unsigned short	get_ake6_pos(void)
{
	unsigned short	r=0;
	unsigned char	i;
	unsigned short	hiru_yoru_hun;
	unsigned short	keika_hun;
	unsigned short	ake;
	unsigned short	kure;
	unsigned short	now;
	unsigned long	sekki;
	unsigned long	ima;

	// ݎrp̒lɂ
	ima   = gRTC_mon;
	ima <<= 8;
	ima  |= gRTC_day;
	ima <<= 8;
	ima  |= gRTC_hou;
	ima <<= 8;
	ima  |= gRTC_min;
	for(i=24;0 < i;i--){
		// ߋCrp̒lɂ
		sekki   = sTime_ake6_kure6[i][0];
		sekki <<= 8;
		sekki  |= sTime_ake6_kure6[i][1];
		sekki <<= 8;
		sekki  |= sTime_ake6_kure6[i][2];
		sekki <<= 8;
		sekki  |= sTime_ake6_kure6[i][3];

		if(sekki <= ima){		// ̐ߋC͈̔͂ɓ
			break;
		}
	}

	// ܂ߋC̖閾Ɠrp̒lɂ
	ake   = sTime_ake6_kure6[i][2];
	ake <<= 8;
	ake  |= sTime_ake6_kure6[i][3];

	kure   = sTime_ake6_kure6[i][4];
	kure <<= 8;
	kure  |= sTime_ake6_kure6[i][5];

	// ݎrp̒lɂ
	now  =  gRTC_hou;
	now <<= 8;
	now  |= gRTC_min;

	if((ake <= now) && (now <= kure)){	// Ԃ̎
		hiru_yoru_hun = keisan_hiru_yoru(0, sTime_ake6_kure6[i][2], sTime_ake6_kure6[i][3], sTime_ake6_kure6[i][4], sTime_ake6_kure6[i][5]);							// ̕
		keika_hun = keisan_keika(0, sTime_ake6_kure6[i][2], sTime_ake6_kure6[i][3], gRTC_hou, gRTC_min);																// Z̌oߕ
		r = (unsigned short)(((unsigned long)(Step_of_Round / 2) * (unsigned long)keika_hun) / (unsigned long)hiru_yoru_hun);											// ʒuvZ@S̈ʒuS̕~oߕ
	}else{
		hiru_yoru_hun = keisan_hiru_yoru(1, sTime_ake6_kure6[i][4], sTime_ake6_kure6[i][5], sTime_ake6_kure6[i][2], sTime_ake6_kure6[i][3] );							// ̕
		keika_hun = keisan_keika(1, sTime_ake6_kure6[i][4], sTime_ake6_kure6[i][5], gRTC_hou, gRTC_min);																// Z̌oߕ
		r = (unsigned short)(((unsigned long)(Step_of_Round / 2) * (unsigned long)keika_hun) / (unsigned long)hiru_yoru_hun);											// ʒuvZ@S̈ʒuS̕~oߕ
		r += (Step_of_Round / 2);
	}

#ifdef	deb_disp
	disp_step_pos(hiru_yoru_hun,7);				//	@͖́@ifobOpj
	disp_step_pos(keika_hun,12);				//	o߁@ifobOpj
	disp_step_pos(i,17);						//	ԖځifobOpj
#endif

	return(r);
}

