//*******************************************************
//@@ohbPUePWSV ZvvO@uQ
//@@ PIC16F1847 AKE MUTU Clock Program
//  file name: main.c
//
//   MPLAB IDE v8.84  HiTEC C
//   [C:\Program Files\HI-TECH Software\PICC\9.83\include\as16f1847.h] include 
//
//  2013/11/18  New  Programed by Taishi
//  2014/04/30  Modify for 16F1827  Taishi
//  2015/05/09  modify for 16F1847  Taishi
//  2015/08/17  modify for ake6 ver2  Taishi iv̔@\ǉj
//*******************************************************

#include	<htc.h>

#include	<string.h>

#include	"16F1847_ake6_clock2.h"
#include	"step_motor.h"
#include	"LCD.h"
#include	"Rtc_PCF8563.h"
#include	"port_bit.h"
#include	"ake6.h"

// CONFIG for 16F1847

__CONFIG (	FCMEN_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	IESO_OFF			//	0(OFF) = tFCZ[t NbNj^𖳌ɂ
		&	CLKOUTEN_OFF		//	1(OFF) = CLKOUT@\𖳌ɂBCLKOUT sI/O Ƃċ@\
		&	BOREN_ON			//	11 = BOR(uEAEgZbg)Lɂ
		&	CPD_OFF				//	1(OFF) = f[^̃R[hی𖳌ɂ
		&	CP_OFF				//	1(OFF) = vÕR[hی𖳌ɂ
		&	MCLRE_ON			//	0(OFF) = MCLR/VPP s̓fW^͂Ƃċ@\ȂB
		&	PWRTE_ON			//	0 = PWRT(p[Abv^C}[)Lɂ
		&	WDTE_OFF			//	00 = WDT(EHb`hbO^C}[)𖳌ɂ
		&	FOSC_INTOSC			//	100 = INTOSCIV[^:CLKIN sI/O Ƃċ@\
);

								//	fobO@\͏ݑuɔCij

__CONFIG (	LVP_OFF				//	0(OFF)=vO~OMCLR ɍdKv
		&	BORV_LO				//	1 = uEAEgZbgd(Vbor)̃gbv|Cgɐݒ肷
		&	STVREN_ON			//	1(ON) = X^bÑI[o[t[܂̓A_[t[ɂăZbg𔭐
		&	PLLEN_OFF			//	0 = 4xPLL 𖳌ɂ
		&	WRT_OFF				//	11 = ݕیOFF ɂ
);

unsigned char 	gUcd[11];
unsigned char	gRtc_int;		// Ohms
unsigned short	gSet_time;		// 킹XCb`hms
unsigned short	gSet_pos;		// ʒu킹XCb`hms
unsigned short	gSet_bityo=0;	// lC


// ------ TIMER0 ֘A -----
#define	TMR0_COUNT	(78)						// ^C}[OŃJEgli^C}[ɓg͂VWPQgŖPOrԊuɂȂlj
#define	TMR0_DATA	(256-TMR0_COUNT)			// ^C}[ÕJEgJnl
// ------------------------


// *****************************
//	fB[PrŒ
//
// *****************************
void	wait_1ms(void)
{
	__delay_ms(1);			//	Pҋ@;
}
// *****************************
//	fB[POrP
//
// *****************************
void	wait_10ms(unsigned char n)
{
	unsigned char i;

	for(i=0;i<n;i++){
		__delay_ms(10);			//	POҋ@;
	}
}
//***************************
// Timer0 ݒ
//@
//@@F@OݕsA@P݉
//***************************
static	
void	timer0_init(unsigned char enable)
{
	OPTION_REG = 0b00000111;		// vXP[g@1/256A(8/4)MHzȂ̂7812HzNbN^C}[Oɓ
	if(enable == 0){
		TMR0 = 0;					// JE^[ݒ
		TMR0IE = 0;					// slqO̊ݕs
		TMR0IF = 0;					// ^C}[OI[o[t[tONA
	}else{
		TMR0 = TMR0_DATA;			// JE^[Đݒ
		TMR0IF = 0;					// ^C}[OI[o[t[tONA
		TMR0IE = 1;					// slqO̊݉
	}
}
//***************************
// RTC INT* 
//  O݁ioaOj PCF8565  INT* MĂ
//***************************
void	interrupt isr(void)
{
	if(INTF == 1){							// O݂L
		gRtc_int = 1;						// hms
		INTF = 0;							// tONA
	}

	if(IOCIF == 1){							// Ԋ݂L
		if(IOCBF6 == 1){					// 킹XCb`iqaUjꂽ
			gSet_time=1;
		}
		if(IOCBF7 == 1){					// ʒu킹XCb`iqaVjꂽ
			gSet_pos=1;
		}
		IOCBF = 0;							// tONA
	}

	if(TMR0IF == 1){						// ^C}[OI[o[t[݂L
		TMR0 = TMR0_DATA;					// JE^[Đݒ

		if(gTim_10ms_sw != 0){				// XCb`pPOrPʃ^C}[
			gTim_10ms_sw--;
		}

		if(gTim_10ms_sw1_length != 0){		// EXCb`pԂPOrPʃ^C}[
			gTim_10ms_sw1_length--;
		}

		if(gTim_10ms_sw1_continue != 0){		// EXCb`pAPOrPʃ^C}[
			gTim_10ms_sw1_continue--;
		}

		if(gTim_10ms_sw2_length != 0){		// XCb`pԂPOrPʃ^C}[
			gTim_10ms_sw2_length--;
		}

		if(gTim_10ms_sw2_continue != 0){		// XCb`pAPOrPʃ^C}[
			gTim_10ms_sw2_continue--;
		}

		TMR0IF = 0;							// ^C}[OI[o[t[tONA
	}
}

const	unsigned char	xpos_dsp[5]={2,5,8,1,4};		// \̈ʒu
//***************************
// v
//  XCb`̒ZŎ̍ڂֈړ
//  XCb`̒ŒlŏI
//  EXCb`̉Œl{P
//***************************
void	adjust_time(void)
{
	unsigned char	uc = 1;
	unsigned char	adj = 1;
	unsigned char	count_50=50;
	unsigned char	ten = 0;								// OF\͉ȂAPF\AQF\
	unsigned char	uru;
	unsigned char	syo;
	unsigned char	henkou = 0;

	disp_one_char_lcd_G_10x16(0, 2, '.');

	wait_sw_off();											// XCb`nee҂

	while(1){
		uc = get_action_sw();									//@XCb`Ԃ
		if(sw[1] != 0){											// XCb`Ă鎞
			ten = 0;
		}else if(count_50 != 0){
			count_50--;
		}else{
			if(ten == 1){
				ten = 2;
			}else{
				ten = 1;
			}
			count_50 = 25;
		}

		if((uc & SW2_OFF_LONG) != 0){							// XCb`ėꂽ
			if(henkou == 1){									// ύXĂ
				gRTC_sec = 0;
				rtc_write_PCF8563();
			}
			disp_lcd_G_YMDHM_10x16();							//  NAA̍ĕ\
			break;												// ̊֐甲
		}else if((uc & SW2_OFF_SHORT) != 0){					// XCb`Zėꂽ
			switch(adj){
			 case 1:											// N̎
				disp_lcd_G_YEAR_10x16();						//  N̕\
				break;
			 case 2:											// ̎
				disp_lcd_G_MON_10x16();							//  ̕\
				break;
			 case 3:											// ̎
				disp_lcd_G_DAY_10x16();							//  ̕\
				break;
			 case 4:											// ̎
				disp_lcd_G_HOU_15x24();							//  ̕\
				break;
			 case 5:											// ̎
				disp_lcd_G_MIN_15x24();							//  ̕\
				break;
			}
			adj++;												// 
			if(5 < adj){
				adj = 1;
			}
			ten = 1;
			count_50 = 0;
		}else if(((uc & SW1_ON_CONTINUE) != 0)||((uc & SW1_OFF_SHORT) != 0)){	// EXCb`ꂽ
			henkou = 1;
			switch(adj){
			 case 1:											// N̎
				gRTC_year++;									// N{P
				if(9 < (gRTC_year & 0x0f)){
					gRTC_year += 6;
					if(0x99 < gRTC_year){
						gRTC_year = 0;
					}
				}
				break;
			 case 2:											// ̎
				gRTC_mon++;										// {P
				if(9 < (gRTC_mon & 0x0f)){
					gRTC_mon += 6;
				}
				if(0x12 < gRTC_mon){
					gRTC_mon = 1;
				}
				break;
			 case 3:											// ̎
				uru = 0;
				syo = 0;

				gRTC_day++;										// {P
				if(9 < (gRTC_day & 0x0f)){
					gRTC_day += 6;
				}
				if(((((gRTC_year/16)*10)+(gRTC_year/16))/4) == 0){	// 邤N
					uru=1;
				}
				if((gRTC_mon == 0x04)||(gRTC_mon == 0x06)||(gRTC_mon == 0x09)||(gRTC_mon == 0x11)){	// ̌
					syo=1;
				}
				if(syo == 1){									// ̌
					if(0x30 < gRTC_day){
						gRTC_day = 1;
					}
				}else if(gRTC_mon == 0x02){
					if(uru == 1){								// Q 邤N
						if(0x29 < gRTC_day){
							gRTC_day = 1;
						}
					}else{										// Q N
						if(0x28 < gRTC_day){
							gRTC_day = 1;
						}
					}
				}else{											// ̌
					if(0x31 < gRTC_day){
						gRTC_day = 1;
					}
				}
				break;
			 case 4:											// ̎
				gRTC_hou++;										// {P
				if(9 < (gRTC_hou & 0x0f)){
					gRTC_hou += 6;
				}
				if(0x23 < gRTC_hou){
					gRTC_hou = 0;
				}
				break;
			 case 5:											// ̎
				gRTC_min++;										// {P
				if(9 < (gRTC_min & 0x0f)){
					gRTC_min += 6;
				}
				if(0x59 < gRTC_min){
					gRTC_min = 0;
				}
				break;
			}
			ten = 1;
			count_50 = 25;
		}

		// ̐̓_
		if(ten == 1){								// _ł̓_ɂȂ
			switch(adj){
			 case 1:								// N
				disp_lcd_G_YEAR_10x16();			//  N̕\
				break;
			 case 2:								// 
				disp_lcd_G_MON_10x16();				//  ̕\
				break;
			 case 3:								// 
				disp_lcd_G_DAY_10x16();				//  ̕\
				break;
			 case 4:								// 
				disp_lcd_G_HOU_15x24();				//  ̕\
				break;
			 case 5:								// 
				disp_lcd_G_MIN_15x24();				//  ̕\
				break;
			 default:
				break;
			}
		}else if(ten == 2){								// _ł̖łɂȂ
			gUcd[0] = ' ';
			gUcd[1] = ' ';
			gUcd[2] = 0x00;
			switch(adj){
			 case 1:								// N
			 case 2:								// 
			 case 3:								// 
				disp_lcd_G_10x16(xpos_dsp[adj-1], 0, gUcd);
				break;
			 case 4:								// 
			 case 5:								// 
				disp_lcd_G_15x24(xpos_dsp[adj-1], 1, gUcd);
				break;
			}
		}
	}
	disp_one_char_lcd_G_10x16(0, 2, ' ');
}

//***************************
// ʒu
//  XCb`̒ō̈ʒu_iʒu[jɂ
//  EXCb`̉Œl{P
//***************************
void	adjust_pos(void)
{
	unsigned char	step = 0;
	unsigned char	uc;
	unsigned char	i;
	static	unsigned char	setpos[] = {"SET POS"};
	static	unsigned char	ake6[] = {"AKE-6"};

	disp_clear_lcd_G();
	disp_lcd_G_15x24(0, 0, setpos);
	disp_lcd_G_15x24(1, 1, ake6);

#ifdef	deb_disp
 #ifdef	Drive_1_2									// P|Q㎥
	disp_one_char_lcd_G_10x16(0, 1, '1');
	disp_one_char_lcd_G_10x16(0, 2, '2');
 #else
  #ifdef Drive_2									// Q㎥
	disp_one_char_lcd_G_10x16(0, 1, ' ');
	disp_one_char_lcd_G_10x16(0, 2, '2');
  #else												// P㎥
	disp_one_char_lcd_G_10x16(0, 1, '1');
	disp_one_char_lcd_G_10x16(0, 2, ' ');
  #endif
 #endif
#endif

	wait_sw_off();							// XCb`nee҂

	while(1){
		uc = get_action_sw();				//@XCb`Ԃ

		if((uc & SW2_OFF_LONG) != 0){		// XCb`ėꂽ
			step_move(0, 0, 0, 1);			// ̈ʒu_Ƃ
			break;
		}

		if((sw[1] & 0b01000000) != 0){		// EXCb`nm̎
			led_on();						//  LED ON
			step_move(1, 1, 0, 0);			//@XebsO[^쓮
			led_off();						//  LED OFF
			for(i=0;i< 50-(step*10);i++){
				wait_10ms(1);				//	ҋ@Ԃ񂾂ZȂ;
				uc = get_action_sw();		//@XCb`Ԃ
			}
			step++;
			if(5 < step){
				step = 5;
			}
		}else{
			step = 0;
		}
	}
}

//***************************************
// P̔l\
//   l̉ԖځiO`QRj
//***************************************
void	disp_bityo(unsigned char uc)
{
	signed char	sc;

	sc = bityousei[uc];					// l

	gUcd[2] = 0x00;
	gUcd[0] = (uc / 10)+'0';
	gUcd[1] = (uc % 10)+'0';
	disp_lcd_G_15x24(0, 1, gUcd);		// ԍ\

	if(sc == 0){						// lO
		gUcd[0] = ' ';
		gUcd[1] = '0';
	}else if(0 < sc){					// lvX
		gUcd[0] = '+';
		gUcd[1] = (sc % 10)+'0';
	}else{								// l}CiX
		gUcd[0] = '-';
		gUcd[1] = ((0-sc) % 10)+'0';
	}
	disp_lcd_G_15x24(4, 1, gUcd);		// l\

}
//***************************************
// l̏C
//***************************************
void	adjust_bityo(void)
{
	unsigned char			uc = 0;
	unsigned char			ud = 0;
	disp_clear_lcd_G();
	disp_lcd_G_10x16(0, 0, (unsigned char *)("ADJ. BITYO"));
	wait_sw_off();												// XCb`nee҂

	disp_bityo(uc);												// P̔l\
	disp_lcd_G_15x24(2, 1,(unsigned char *)("H="));				//  l̏ČŒ蕔\

	while(1){
		uc = get_action_sw();									//@XCb`Ԃ

		if((uc & SW2_OFF_LONG) != 0){							// XCb`ėꂽ
			bityousei_sum = get_bityou_sum();					// l̃TvZŋ߂
			di();												//	荞݋֎~
			wtite_bityousei();									// l
			GIE = 1;											// SĂ̊݉
			break;												// ̊֐甲
		}else if((uc & SW2_OFF_SHORT) != 0){					// XCb`Zėꂽ
			ud++;												// ̔l
			if(24 <= ud){
				ud = 0;
			}
			disp_bityo(ud);										// P̔l\
		}else if(((uc & SW1_ON_CONTINUE) != 0)||((uc & SW1_OFF_SHORT) != 0)){	// EXCb`ꂽ
			bityousei[ud]++;									// l{P
			if(9 < bityousei[ud]){
				bityousei[ud] = -9;
			}
			disp_bityo(ud);										// P̔l\
		}
	}

}

#ifdef	deb_disp
//***************************************
//	ʒu̕\ifobOpj
//***************************************
void	disp_step_pos(unsigned short pos, unsigned char x)
{
	static	unsigned char	ucp[5];

	ucp[0] = (pos/1000)+'0';
	ucp[1] = ((pos%1000)/100)+'0';
	ucp[2] = ((pos%100)/10)+'0';
	ucp[3] = (pos%10)+'0';
	ucp[4] = 0;
	disp_lcd_G(x, 2, &(ucp[0]));
}
#endif

const	unsigned char	conv[12][5]={
	{'J','a','n','0','1'},
	{'F','e','b','0','2'},
	{'M','a','r','0','3'},
	{'A','p','r','0','4'},
	{'M','a','y','0','5'},
	{'J','u','n','0','6'},
	{'J','u','l','0','7'},
	{'A','u','g','0','8'},
	{'S','e','p','0','9'},
	{'O','c','t','1','0'},
	{'N','o','v','1','1'},
	{'D','e','c','1','2'},
};
//***************************************
//@N̓{̎擾			*
//***************************************/
unsigned char	*convert_date(void)
{
	static	unsigned char	cbf[22];
	unsigned char			i;

	cbf[0] = *(__DATE__ + 7);
	cbf[1] = *(__DATE__ + 8);
	cbf[2] = *(__DATE__ + 9);
	cbf[3] = *(__DATE__ + 10);
	cbf[4] = '-';
	cbf[5] = '1';
	cbf[6] = '2';
	for(i=0;i<12;i++){
		if((*(__DATE__ + 0) == conv[i][0])&&(*(__DATE__ + 1) == conv[i][1])&&(*(__DATE__ + 2) == conv[i][2])){
			cbf[5] = conv[i][3];
			cbf[6] = conv[i][4];
			break;
		}
	}
	cbf[7] = '-';
	cbf[8] = *(__DATE__ + 4);
	cbf[9] = *(__DATE__ + 5);
	cbf[10] = 0;

	return(cbf);
}

//***************************************
// ̌㏈
//***************************************
void	adjproc_end(void)
{
	timer0_init(0);					// Timer0 ݒAݕs
	sw_interrupt_set(1);			//@XCb`̊݉
	disp_clear_lcd_G();
	rtc_read_PCF8563();				// RTC ǂݏo
	disp_lcd_G_YMDHM_10x16();		//  NAA̕\
	disp_lcd_G_YMDHM_FIX_10x16();	//  NAǍŒ蕔\
}

//***************************************
//@C								*
//***************************************/
void	main(void)
{
	unsigned short	pos;
	unsigned char	set_time=0;

	di();							//	荞݋֎~

//				76543210
//	OSCCON	= 0b01110000;			//	NbNWlg@c@okkHLȂ̂ŎRQlg
	OSCCON	= 0b01110010;			//	NbNWlg

//				76543210			//  |[g`
	ANSELA	= 0b00000000;			//	ăfW^óiAiO͋֎~j
	PORTA	= 0b00000000;			//	o̓f[^ݒ(SĂO)
	TRISA	= 0b00100000;			//	o͕ݒ(RA5ȊOSďo)
	WPUA	= 0b00000000;			//	vAbvݒ(SăvAbv)


//				76543210			//  |[gb
	ANSELB	= 0b00000000;			//	ăfW^óiAiO͋֎~j
	PORTB	= 0b00000000;			//	o̓f[^ݒ(SĂO)
	TRISB	= 0b11000001;			//	o͕ݒ(PB7,6,0=OUTOUT,͏o)
	WPUB	= 0b11000001;			//	vAbvݒ(RB7,6,0=PULL UP,̓vAbv)

	OPTION_REG &= 0b01111111;		// Ŝ̃vAbvLɂ(WPUEN*:L)

	wait_10ms(10);					//	POOҋ@;
	init_lcd_G();					// Init. LCD
	rtc_init_PCF8563();				// RTC Initial

	if((RB6 == 0)&&(RB7 == 0)){		// RB7,6:Low(Switch ON)
		wait_10ms(2);				//	QOҋ@;
		if((RB6 == 0)&&(RB7 == 0)){	// RB7,6:Low(Switch ON)
			gSet_bityo = 1;			// lC
		}
	}

	disp_lcd_G_10x16(0, 0, convert_date());
	disp_lcd_G_10x16(0, 1, (unsigned char *)(__TIME__));
	disp_lcd_G_10x16(0, 2, (unsigned char *)(AKE6_VER));

	wait_10ms(250);					//	2.5Secҋ@;
	wait_10ms(250);					//	2.5Secҋ@;

	led_on();						//  LED ON
	step_move(0, 0, 0, 1);			//  ̈ʒu_Ƃ
	wait_10ms(5);					//	TOҋ@;
	led_off();						//  LED OFF


	GIE = 1;						// Ŝ̊ݗL

	if(gSet_bityo != 0){			// lC鎞
		sw_interrupt_set(0);		//@XCb`̊ݕs
		timer0_init(1);				// Timer0 ݒA荞݉
		adjust_bityo();				// l̏C
		gSet_bityo = 0;
		adjproc_end();				// ̌㏈
	}

	gRtc_int = 0;					// hmstONA
	gSet_time = 1;
	set_time = 1;
	gSet_pos = 1;


	while(1){
		if(gSet_pos != 0){
			sw_interrupt_set(0);		//@XCb`̊ݕs
			step_move(0, 1, 1, 0);		//@Z̈ʒu܂łɓ
			timer0_init(1);				// Timer0 ݒA荞݉
			adjust_pos();				// ʒu
			gSet_pos = 0;
			adjproc_end();				// ̌㏈
			pos = get_ake6_pos();			//  ݎ@uZAZv̈ʒu߂
#ifdef	deb_disp
			disp_step_pos(pos,0);			//	ʒu̕\ifobOpj
#endif
			step_move(pos, 1, 1, 0);		//@XebsO[^쓮
			if(set_time == 1){
				gSet_time = 1;
			}
		}

		if(gRtc_int == 1){				// 荞݂
			gRtc_int = 0;
			rtc_read_PCF8563();			// RTC ǂݏo
			disp_lcd_G_YMDHM_10x16();	//  NAA̕\
			pos = get_ake6_pos();		//  ݎ@uZAZv̈ʒu߂
			rtc_adjust_PCF8563();		// RTC 
#ifdef	deb_disp
			disp_step_pos(pos,0);		//	ʒu̕\ifobOpj
#endif
			step_move(pos, 1, 1, 0);	//@XebsO[^쓮
		}

		if(gSet_time != 0){
			sw_interrupt_set(0);		//@XCb`̊ݕs
			timer0_init(1);				// Timer0 ݒA荞݉
			adjust_time();				// v
			gSet_time = 0;
			set_time = 0;
			timer0_init(0);				// Timer0 ݒAݕs
			sw_interrupt_set(1);		//@XCb`)̊݉

#ifdef	deb_disp
			disp_step_pos(pos,0);		//	ʒu̕\ifobOpj
#endif
			pos = get_ake6_pos();		//  ݎ@uZAZv̈ʒu߂
			step_move(pos, 1, 1, 0);	//@XebsO[^쓮
		}

		SLEEP();
		NOP();
	}
}
